import type { AnyObject, DraftMeta, IApiCtx, ObjectLike, RootCtx } from '../inner-types';
export declare const ROOT_CTX: RootCtx;
export declare function markModified(meta: DraftMeta): void;
export declare function attachMeta(dataNode: any, meta: DraftMeta, options: {
    fast: boolean;
    apiCtx: IApiCtx;
}): any;
export declare function getKeyPath(draftNode: any, curKey: string, apiCtx: IApiCtx): string[];
export declare function newMeta(key: any, baseData: any, options: any): DraftMeta<AnyObject<any>>;
/**
 * 是否是一个草稿对象代理节点
 */
export declare function isDraft(mayDraft: any): boolean;
export declare function genMetaVer(): string;
export declare function getNextMetaLevel(mayContainMetaObj: any, apiCtx: IApiCtx): number;
export declare function getSafeDraftMeta<T = ObjectLike>(proxyDraft: T, apiCtx: IApiCtx): DraftMeta<T>;
export declare function getDraftMeta(proxyDraft: any, apiCtx?: IApiCtx): DraftMeta<any> | null;
export declare function getMetaVer(mayDraftProxy: any): string;
export declare function getApiCtx(mayDraftProxy: any): IApiCtx | null;
export declare function getDraftProxyMeta(mayDraftProxy: any): DraftMeta<AnyObject<any>> | null;
/**
 * 判断两个值是否相同，true 表示不相等，false 表示相等
 */
export declare function isDiff(val1: any, val2: any): boolean;
/**
 * 浅比较两个对象，除了专用于比较 helux 生成的代理对象，此函数还可以比较普通对象
 * ```txt
 * true：两个对象一样
 * false：两个对象不一样
 * ```
 */
export declare function shallowCompare(prevObj: AnyObject, nextObj: AnyObject, compareLimuProxyRaw?: boolean): boolean;
